/* 
 * File:   TERREG.c
 * Author: Aleksandr
 *
 * Created on 17  2019 ., 20:45
 */

#include <stdio.h>
#include <stdlib.h>
#include <htc.h>

#define _XTAL_FREQ 4000000
#define __delay_us(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000000.0)))
#define __delay_ms(x) _delay((unsigned long)((x)*(_XTAL_FREQ/4000.0)))
#define TERREG RA6		// 

__EEPROM_DATA(0,0,0,0, 0,0,0,0);
__EEPROM_DATA(0,0,0,0, 0,0,0,0);

#define BOL RA4		//  
#define MEN RA5		//  
#define K RA7		//  DS18B20
#define Ki TRISA7=1	//   
#define Ko TRISA7=0	//   
#define ON 1            // -  .
#define OFF 0           // -  .

void main(void);
void display(void);
unsigned char start_reset(void);
void porazr(void);
void command(unsigned char cmnd);
unsigned char reading (void);
void zapeep(void);

 __CONFIG(LVPDIS & MCLRDIS & WDTDIS & UNPROTECT & INTIO & UNPROTECT);	// 

#define BITNUM(adr,bit)((unsigned)(&adr)*8+(bit)) //

unsigned char BUFKR,GISTER, MAT, MMEE, MMEI, MPEE, PPEE;
unsigned char d1,d2,d3,d4,minus,BOLDI, BOLD, BLLDI, BLLD, BLGD;
signed short( TERUST );
unsigned short( v );
signed short( term );
unsigned int BBLD;

const char con_dro[] = { 0, 1, 1, 2, 2, 3, 4, 4, 5, 6, 6, 7, 7, 8, 9, 9, 00}; 

static bit DB7  @ BITNUM(PORTB,7); //   /  / 
bit FLAG_0;         // .
bit FLAG_1;         // .
bit FLAG_2;         // .
bit FLAG_3;         // .
bit FLAG_4;         // .
bit FLAG_5;         // .
bit FLAG_6;         // .
bit FLAG_7;         // .

void main(void){
	unsigned char termL, termH;
	CMCON = 0b111;		// 
	TRISB = 0b10000000;      //RB 7  
	TRISA = 0b10110000;      //RA 4,5  

	TERREG = 0;
        GISTER = EEPROM_READ(3);   //  

  for (int index = 1; index >= 0; index--)     // 2  EEPROM
	{
		TERUST += EEPROM_READ(index);
		if (index != 0) TERUST <<= 8;
	}

	d1=d2=d3=0;	
       BLGD=BUFKR=0;
for(;;){
		display();    //
//********************************************************
//********************************************************
if (DB7==0)      //   /  / 
{
 if (FLAG_0==0)  //
{              //
    BUFKR++;;  //  /  / 
    FLAG_0=ON;        //
     if(BUFKR==3)BUFKR=0;
}              //
 }
else     // 
{            //
    FLAG_0=OFF;    //
}            //

//********************************************************
		display();    //
     if (BUFKR==0)      // 
                  {     //
                BBLD=0;
		start_reset();	     //  RESET ( presence) 
                display();	//
		command(0xCC);	     //  
		command(0x44);	     //  ( )
                display();	//
		start_reset();	     //  RESET ( presence) 
                display();	//  
		command(0xCC);	     //   0xCC
		command(0xBE);	     //  0xBE     
                display();	//  
		termL=reading();     //   
		termH=reading();     //       
                display();	//

                   BLGD++;
              if (BLGD >= 74)   //    
                {
		term = termL;     
                term+=termH<<8;	    // 
                 BLGD=74;
                           }	

                d4=0;
                minus=0;
            if (term & 0x8000)    // 
            {
            term=-term; //  
            minus=1;
                        }	

           if(minus) d4=10;	//   
           if(d4==0 && minus==0) d4=11;	//  ,   

     termH=term;		//   
     termH &= 0b00001111;	// 
     termH=con_dro[termH];		//
						
     term>>=4;	              //   
     term=(term&0x00ff)*10;   //  225-22,5
     term=term+termH;	      // 

           if(MAT)    //MAT=1  
             {
	 if (TERREG == 1) {
	if (minus == 0){if (term > TERUST + GISTER) TERREG = 0;}   // minus=0 
	  else{
		 if (-term > TERUST + GISTER) TERREG = 0;}
	 } else {
	if (minus == 0){if (term < TERUST) TERREG = 1;}   // minus=0 
	  else{
		 if (-term < TERUST) TERREG = 1;
	      }
	 }
	    }
	  else
             {
	 if (TERREG == 1) {
	if (minus){if (-term > TERUST + GISTER) TERREG = 0;} // minus=1 . 
	  else{
		 if (term > TERUST + GISTER) TERREG = 0;}
	 } else {
	if (minus){if (-term < TERUST) TERREG = 1;}
	  else{
		 if (term < TERUST) TERREG = 1;}
	 }
	    }

            v=term;

           porazr();	//

		display();	//

 //***************************************************************************************************
     } // ----++++
  if (BUFKR==1)      // ----++++
        {      //----++++
         d4=0;
 //****************************
  if (BOL==0)      // ++++
   {      // ++++
 //********
     BBLD=0;
     BLLD++;
  if (BLLD >= 77)   // 2 
   {      // 
     GISTER++;
     __delay_ms(7);
     if(GISTER==101)GISTER=100;
     BLLD=77;
    } //
  if (BLLDI==0)  //
   {   //
     GISTER++;
     if(GISTER==101)GISTER=100;
     BLLDI=1;
     PPEE=1;
    } //
    } // ++++
else     // 
   {  //
  if (PPEE==1)  {     //
  EEPROM_WRITE(3, GISTER); PPEE=0; }  //  
     BLLD=0;
     BLLDI=0;

     BBLD++;
  if (BBLD >= 2754)   //  25 
   {      // 
   BUFKR=0;
    }

    } //
 //********
 //****************************
  if (MEN==0)      // ----
      {      // ----
 //********
     BBLD=0;
     BOLD++;
  if (BOLD >= 77)   // 2 
   {      // 
     GISTER--;
     __delay_ms(7);
     if(GISTER==255)GISTER=0;
     BOLD=77;
    } //
  if (BOLDI==0)  //
   {   //
     GISTER--;
     if(GISTER==255)GISTER=0;
     BOLDI=1;
     MPEE=1;
    } //
    } // ----
else     // 
   {  //

  if (MPEE==1)  {     //
  EEPROM_WRITE(3, GISTER); MPEE=0; }  //  

     BOLD=0;
     BOLDI=0;

    } //
 //********
    }

 //****************************
 //****************************
  if (BUFKR==2)      // ----++++
        {      //----++++
 //****************************
         d4=0;
  if (BOL==0)      // 
   {   // ++++
 //********
     BBLD=0;
     BLLD++;
  if (BLLD >= 77)   // 2 
   {      // 
     TERUST++;
     __delay_ms(7);
     if(TERUST==1251)TERUST=1250;
     BLLD=77;
    } //
  if (BLLDI==0)  //
   {   //
     TERUST++;
     if(TERUST==1251)TERUST=1250;
     BLLDI=1;
      MMEE=1;
    } //
    } // ++++
else     // 
   {  //

  if (MMEE==1)  {     //
      zapeep();    //  2 
      MMEE=0;
	  }

     BLLD=0;
     BLLDI=0;

     BBLD++;
  if (BBLD >= 2754)   // 25 
   {      // 
   BUFKR=0;
    }

    } //
 //********
 //****************************
  if (MEN==0)      // ----
      {      // ----
 //********
     BBLD=0;
     BOLD++;
  if (BOLD >= 77)   // 2 
   {      // 
     TERUST--;
     __delay_ms(7);
     if(TERUST<-550)TERUST=-550;
     BOLD=77;
    } //
  if (BOLDI==0)  //
   {   //
     TERUST--;
     if(TERUST<-550)TERUST=-550;
     BOLDI=1;
      MMEI=1;
    } //
    } // -----
else     // 
   {  //

  if (MMEI==1)  {     //
      zapeep();   //  2 
      MMEI=0;
	  }

     BOLD=0;
     BOLDI=0;
    } //
 //********
   } 

 //****************************
  if (BUFKR==1)      // ----++++
           {      
     v=GISTER;   // 
      }
  if (BUFKR==2)      // ----++++
            {  
	if (TERUST >= 0) {
     v=TERUST;   //  
       MAT = 0;
	}
 else { 
 v=-TERUST;
 d4 = 10; //   
 MAT = 1;
 }
     }
  if (BUFKR==1||BUFKR==2)      // ----++++
            {  
   porazr();   //   

      display();   //
                }
            } // ----++++
		
	}
 
//***************************************************************************************************						
void display(){ //
	unsigned char digit[12];
	     //  OA GFEDCBA            OK GFEDCBA
	digit[0]=0b11000000;      //0  0b10111111;  7  
	digit[1]=0b11111001;      //1  0b10000110;
	digit[2]=0b10100100;      //2  0b11011011;
	digit[3]=0b10110000;      //3  0b11001111;
	digit[4]=0b10011001;      //4  0b11100110;
	digit[5]=0b10010010;      //5  0b11101101;
	digit[6]=0b10000010;      //6  0b11111101;
	digit[7]=0b11111000;      //7  0b10000111;
	digit[8]=0b10000000;      //8  0b11111111;
	digit[9]=0b10010000;      //9  0b11101111;
       digit[10]=0b10111111;       //  0b11000000;    
       digit[11]=0b11111111;	   //
	   
	
		PORTB=digit[d1];
		RA0=1;
		__delay_us(450);
		RA0=0;
		PORTB=digit[d2];
		RA1=1;
		__delay_us(450);
		RA1=0;
		PORTB=digit[d3];
		RA2=1;
		__delay_us(450);
		RA2=0;
		PORTB=digit[d4];
		RA3=1;
		__delay_us(450);
		RA3=0;
                   }	

 //***************************************************************************************************
 
unsigned char reading (void){              //  
	unsigned char ret=0,i;          //     DS18B20
	
      for(i=0;i<8;i++){	// 8 
        Ko; K=0; __delay_us(2); Ki; __delay_us(6);
          if(K){ret += 1 << i;} __delay_us(80);	//
	}
	Ki;
	return ret;
}
 
//***************************************************************************************************
void command(unsigned char cmnd){      //   DS18B20
	unsigned char i;          // DS18B20
	
     for(i=0;i<8;i++){	//8 
       if(cmnd & (1 << i)){Ko; K=0; __delay_us(2); Ki; __delay_us(80);}

        else{Ko; K=0; __delay_us(80); Ki; __delay_us(2);}   //
	}
	Ki;
	
}
 
//***************************************************************************************************
                     //  RESET ( presence) DS18B20
unsigned char start_reset(void){	   
	
	Ko;
	K=0; __delay_us(500);
	Ki; __delay_us(400);
	return K;	//
	
           }		
 //***************************************************************************************************

void zapeep(void){ 
	  int shift = 0;      //
	  for ( int index = 0; index < 2; index++) {
		  EEPROM_WRITE(index, TERUST >> shift & 0xFF);
		  shift += 8; }
	             }
 //***************************************************************************************************
void porazr(void){

     d1 = v % 10;
     v = v / 10;
        
     d2 = v % 10;
     v = v / 10;

     d3 = v % 10;
     v = v / 10;

     d4 = v % 10;
     v = v / 10;

  if (BUFKR==0){if(minus) d4=10;}  //    
                     
           
  if (BUFKR==2){if(MAT) d4=10;}	//    
           
	             }





